if ('undefined' !== typeof versions) versions.register('innovator.js', '2013.06.04.1032');
var IOM = {
    LockStatus: {
        NotLocked: 0,
        LockedByUser: 1,
        LockedByOther: 2
    },
    Innovator: function (connection) {
        if ('undefined' === typeof connection) connection = null;

        var _clientInnovator = (top.aras && top.aras.newIOMInnovator ? top.aras.newIOMInnovator() : null);
        var _conn = connection;
        var _userFullName;
        var self = this;
      
        // Get an XML parser;
        var parseXml;
        if (typeof window.DOMParser != "undefined") {
            parseXml = function(xmlStr) {
                return ( new window.DOMParser() ).parseFromString(xmlStr, "text/xml");
            };
        } else if (typeof window.ActiveXObject != "undefined" &&
               new window.ActiveXObject("Microsoft.XMLDOM")) {
            parseXml = function(xmlStr) {
                var xmlDoc = new window.ActiveXObject("Microsoft.XMLDOM");
                xmlDoc.async = "false";
                xmlDoc.loadXML(xmlStr);
                return xmlDoc;
            };
        } else {
            throw new Error("No XML parser found");
        }

        this.applyAML = function (AML, callback) {
            if (_clientInnovator) {
                callback(_clientInnovator.applyAML(AML), AML);
            } else {
                self.CallAction("ApplyAML", AML, callback);
            }
        };
        this.applyMethod = function (methodName, body, callback) {
            if (_clientInnovator) {
                callback(_clientInnovator.applyMethod(methodName, body));
            } else {
                var AML = "<Item type='Method' action='" + methodName + "'>" + body + "</Item>"
                self.CallAction("ApplyMethod", AML, callback);
            }
        };
        this.applySQL = function (sql, callback) {
            if (_clientInnovator) {
                callback(_clientInnovator.applySQL(sql), sql);
            } else {
                var AML = "<sql>" + sql + "</sql>"
                self.CallAction("ApplySQL", AML, callback);
            }
        };
        this.CallAction = function (action, query, callback) {
            function xmlToJson(xml) {
              // Create the return object
              var obj = null;
          
              if (xml.nodeType === 1) { // element
                // do attributes
                if (xml.attributes.length > 0) {
                  if (!obj) obj = {};
                  
                  for (var j = 0; j < xml.attributes.length; j++) {
                    var attribute = xml.attributes.item(j);
                    obj["@" + attribute.nodeName] = attribute.nodeValue;
                  }
                }
              } else if (xml.nodeType === 3) { // text
                obj = xml.nodeValue;
              }
          
              // do children
              if (xml.hasChildNodes()) {
                for(var i = 0; i < xml.childNodes.length; i++) {
                  var item = xml.childNodes.item(i);
                  var nodeName = item.nodeName;
                  
                  if (!(item.nodeType === 3 && /^\s*$/.test(item.nodeValue))) {
                    if (xml.childNodes.length === 1 && xml.nodeType === 1 && xml.attributes.length === 0 && item.nodeType === 3) {
                      obj = item.nodeValue
                    } else if (!obj || typeof(obj[nodeName]) === "undefined") {
                      if (!obj) obj = {};
                      obj[nodeName] = xmlToJson(item);
                    } else {
                      if (!obj) obj = {};
                      if (typeof(obj[nodeName].push) === "undefined") {
                        var old = obj[nodeName];
                        obj[nodeName] = [];
                        obj[nodeName].push(old);
                      }
                      obj[nodeName].push(xmlToJson(item));
                    }  
                  }
                }    
              }
              return obj;
            }
            function jsonToXml(json) {
              function render(obj, xml, o, needsClose) {
                if (obj) {
                  if (Object.prototype.toString.call(obj) === '[object String]') {
                    if (needsClose) {
                      xml[++o] = '>';
                      needsClose = false;
                    }
                    xml[++o] = obj.replace(/&/gi, '&amp;').replace(/</gi, '&lt;').replace(/>/gi, '&gt;');
                  } else if (Object.prototype.toString.call(obj) === '[object Array]') {
                    var name = xml[xml.length - 1];
                    for (var i = 0; i < obj.length; i++) {
                      if (i > 0) {
                        xml[++o] = '</';
                        xml[++o] = name;
                        xml[++o] = '><';
                        xml[++o] = name;
                      }
                      o = render(obj[i], xml, o, true);
                    }
                    needsClose = false;
                  } else {
                    for (var prop in obj) {
                      if (obj.hasOwnProperty(prop)) {
                        if (prop.charAt(0) !== '@' && needsClose) {
                          xml[++o] = '>';
                          needsClose = false;
                        }
                        
                        if (prop.charAt(0) === '@') {
                          xml[++o] = ' ';
                          xml[++o] = prop.substr(1);
                          xml[++o] = '="';
                          xml[++o] = obj[prop].replace(/"/gi, '&quot;').replace(/</gi, '&lt;').replace(/>/gi, '&gt;');
                          xml[++o] = '"';
                        } else if (prop === '#text') {
                          xml[++o] = obj[prop].replace(/&/gi, '&amp;').replace(/</gi, '&lt;').replace(/>/gi, '&gt;');
                        } else {
                          xml[++o] = '<';
                          xml[++o] = prop;
                          o = render(obj[prop], xml, o, true);
                          xml[++o] = '</';
                          xml[++o] = prop;
                          xml[++o] = '>';
                        }
                      }
                    }
                  }
                }
                if (needsClose) xml[++o] = '>';
                return o;
              }
              
              var xml = [];
              var o = -1;
              render(json, xml, o, false);
              return xml.join('');
            }
          
            if (top.aras && 'undefined' !== typeof top.aras.soapSend) {
              var result = top.aras.soapSend(action, query);
              var item = new IOM.Item(this, xmlToJson(result.results));
              item.resultsXML = result.resultsXML;
              
              callback(item, query);
            } else if (_conn && 'undefined' !== typeof _conn.CallAction) {
              _conn.CallAction(action, query, callback);
            } else if (window.external && 'undefined' !== typeof window.external.CallAction) {
              if (query && Object.prototype.toString.call(query) !== '[object String]') query = jsonToXml(query);
              var xml = window.external.CallAction(action, query);
              var item = new IOM.Item(this, xmlToJson(parseXml(xml)));
              item.resultsXML = xml;
              
              callback(item, query);
            } else {
              throw "CallAction: Not Supported";
            }
        };
        this.getConnection = function () {
            if (_clientInnovator) {
                return _clientInnovator.getConnection();
            } else if (_conn) {
                return _conn;
            } else {
                return null;
            }
        };
        this.GetDatabaseName = function () {
            if (_clientInnovator) {
                return _clientInnovator.getConnection().getDatabaseName();
            } else if (_conn) {
                return _conn.GetDatabaseName();
            } else if (window.external && 'undefined' !== typeof window.external.GetDatabaseName) {
                return window.external.GetDatabaseName();
            } else {
                return null;
            }
        }
        this.getItemById = function (itemTypeName, id, callback) {
            if (_clientInnovator) {
                callback(_clientInnovator.getItemById(itemTypeName, id));
            } else {
                if (!itemTypeName || 'undefined' === typeof itemTypeName) {
                    throw "Item type must be specified";
                } else if (!id || 'undefined' === typeof id) {
                    throw "ID must be specified";
                }
                self.CallAction("GetItem", '<Item type="' + itemTypeName + '" id="' + id + '" />', callback);
            }
        };
        this.getItemByKeyedName = function (itemTypeName, keyedName, callback) {
            if (_clientInnovator) {
                callback(_clientInnovator.getItemByKeyedName(itemTypeName, keyedName));
            } else {
                if (!itemTypeName || 'undefined' === typeof itemTypeName) {
                    throw "Item type must be specified";
                } else if (!id || 'undefined' === typeof id) {
                    throw "Keyed name must be specified";
                }
                self.CallAction("GetItem", '<Item type="' + itemTypeName + '"><keyed_name>' + id + '</keyed_name></Item>', callback);
            }
        };
        this.getNewID = function () {
            return IOM.Framework().getNewID();
        };
        this.getUserID = function () {
            if (top.aras && top.aras.getUserID) {
                return top.aras.getUserID();
            } else if (window.external && 'undefined' !== typeof window.external.getUserID) {
                return window.external.getUserID();
            } else {
                return this.getConnection().getUserID();
            }
        };
        this.getUserFullName = function (callback) {
            var conn = this.getConnection();
            if (_userFullName) {
                callback(_userFullName);
            } else if (conn) {
                if (conn.UserFullName && 'undefined' !== typeof conn.UserFullName) {
                    _userFullName = conn.UserFullName
                    callback(_userFullName);
                } else {
                    this.applyAML("<AML><Item type=\"User\" id=\"" + conn.getUserID() + "\" select=\"keyed_name\" action=\"get\" /></AML>", function (item) {
                        _userFullName = item.getProperty("keyed_name", "");
                        callback(_userFullName);
                    });
                }
            }
        };
        this.newItem = function (itemTypeName, action) {
            if (_clientInnovator) {
                return _clientInnovator.newItem(itemTypeName, action);
            } else {
                var itemData = { "Item": { "@isNew": "1"} };
                if (itemTypeName) itemData.Item["@type"] = itemTypeName;
                if (action) itemData.Item["@action"] = action;

                return new IOM.Item((_conn ? _conn : self), itemData);
            }
        };
        this.newError = function (explanation) {
            if (_clientInnovator) {
                return _clientInnovator.newError(explanation);
            } else if (_conn) {
                return _conn._newError(explanation);
            } else {
                throw "newError: Not Supported";
            }
        }
    },
    IomFactory: {
        CreateConnection: function (serviceUrl, database, userName, password) {
            return new IOM.Connection(serviceUrl, database, userName, password);
        },
        CreateInnovator: function (connection) {
            return new IOM.Innovator(connection);
        },
        TryGetInnovator: function (serviceUrl, callback) {
            if ((top.aras && top.aras.newIOMInnovator) || 
                (window.external && 'undefined' !== typeof window.external.CallAction)) {
                callback(true, new IOM.Innovator());
            } else {
                var conn = new IOM.Connection(serviceUrl);
                conn.Login(function () {
                    if (conn.GetDatabaseName()) {
                        callback(true, new IOM.Innovator(conn));
                    } else {
                        callback(false, conn);
                    }
                });
            }
        }
    },
    Connection: function (serviceUrl, database, userName, password) {
        if ('undefined' === typeof database) database = null;
        if ('undefined' === typeof userName) userName = null;
        if ('undefined' === typeof password) password = null;

        var loginEndpoint = "/Login?";
        var searchIndex = serviceUrl.search("[?]");
        if (searchIndex >= 0) {
            var params = (function () {
                var match,
          pl = /\+/g,  // Regex for replacing addition symbol with a space
          search = /([^&=]+)=?([^&]*)/g,
          decode = function (s) { return decodeURIComponent(s.replace(pl, " ")); },
          query = serviceUrl.substring(searchIndex + 1);
                var params = {};
                while (match = search.exec(query)) {
                    params[decode(match[1]).toLowerCase()] = decode(match[2]);
                }
                return params;
            })();
            var pos = serviceUrl.lastIndexOf("/");
            loginEndpoint = serviceUrl.substring(pos, searchIndex + 1);
            serviceUrl = serviceUrl.substr(0, pos);

            if (params["db"] && !database) database = params["db"];
            if (params["u"] && !userName) userName = params["u"];
            if (params["p"] && !password) password = params["p"];
        }

        if (password) password = IOM.Framework().encodePassword(password);

        var self = this;
        var _databaseName = database;
        var _databases = null;
        var _isLoggedIn = false;
        var _userId = null;

        this.UserName = userName;
        this.UserFullName = null;

        this.CallAction = function (action, query, callback) {
            if (!query.substring) query = JSON.stringify(query);

            $.ajax({
                type: "POST",
                dataType: "json",
                url: serviceUrl + "/ApplyPost?a=" + action + "&callback=?",
                data: query,
                timeout: 110000,
                success: function (data) {
                    if (callback) callback(new IOM.Item(self, data), query);
                },
                error: function (jqXhr, textStatus, errorThrown) {
                    var msg = (textStatus ? textStatus : '');
                    if (errorThrown) msg += ': ' + errorThrown;
                    if (callback) callback(self._newError(msg), query);
                }
            });
        };

        this.Login = function (onLogin) {
            $.getJSON(serviceUrl + loginEndpoint + "u=" + (userName ? userName : '') + "&p=" + (password ? password : '') + "&db=" + (database ? database : '') + "&callback=?", function (data) {
                _isLoggedIn = data.success;
                _databaseName = data.database;
                _databases = data.databases;
                _userId = data.userid;
                self.UserName = data.username;
                self.UserFullName = data.userfullname;
                if (onLogin) onLogin(data.success, data.message);
            });
        };

        this.Logout = function (onLogout) {
            $.getJSON(serviceUrl + "/Logout?callback=?", function (data) {
                _isLoggedIn = false;
                _databaseName = "";
                _userId = "";
                self.UserName = "";
                self.UserFullName = "";
                if (onLogout) onLogout();
            });
        }

        this.GetDatabaseName = function () {
            return _databaseName;
        };
        this.GetDatabases = function () {
            return _databases;
        };
        this.getUserID = function () {
            return _userId;
        };

        this._newError = function (explanation) {
            var itemData = {
                "SOAP-ENV:Envelope": {
                    "SOAP-ENV:Body": {
                        "SOAP-ENV:Fault":
                          { "faultcode": "1",
                              "faultstring": explanation
                          }
                    }
                }
            };

            return new IOM.Item(self, itemData);
        };
    },
    Item: function (connection, itemData) {
        var self = this;
        var conn = connection;

        this.json = (itemData ? itemData : { "Item": {} });
        if (itemData["SOAP-ENV:Envelope"] && itemData["SOAP-ENV:Envelope"]["SOAP-ENV:Body"] && itemData["SOAP-ENV:Envelope"]["SOAP-ENV:Body"]["Result"]) this.json = itemData["SOAP-ENV:Envelope"]["SOAP-ENV:Body"]

        function getArrayItem() {
            if (self.json.Result && self.json.Result.Item && Object.prototype.toString.call(self.json.Result.Item) === '[object Array]') {
                return self.json.Result.Item;
            } else {
                return null;
            }
        }

        function getErrorItem() {
            if (self.json["SOAP-ENV:Envelope"] && self.json["SOAP-ENV:Envelope"]["SOAP-ENV:Body"] && self.json["SOAP-ENV:Envelope"]["SOAP-ENV:Body"]["SOAP-ENV:Fault"]) {
                return self.json["SOAP-ENV:Envelope"]["SOAP-ENV:Body"]["SOAP-ENV:Fault"];
            } else {
                return null;
            }
        }

        function getErrorProperty(propertyName) {
            var fault = getErrorItem();

            if (fault && propertyName && 'undefined' !== typeof propertyName) {
                return fault[propertyName];
            } else {
                return false;
            }
        }

        function getSingleItem(item, throwError) {
            if (!item || 'undefined' === typeof item || 'undefined' === typeof item.json) item = self;

            if (item.json.Result && item.json.Result.Item && Object.prototype.toString.call(item.json.Result.Item) !== '[object Array]') {
                return item.json.Result.Item;
            } else if (item.json.Item && Object.prototype.toString.call(item.json.Item) !== '[object Array]') {
                return item.json.Item;
            } else if ('undefined' === typeof throwError || throwError) {
                throw "Not a single item";
            } else {
                return null;
            }
        }



        this.addRelationship = function (relItem) {
            var item = getSingleItem();

            if (relItem.json) {
                if (!item.Relationships || !item.Relationships.Item || Object.prototype.toString.call(item.Relationships.Item) !== '[object Array]') item["Relationships"] = { "Item": [] }
                item.Relationships.Item.push(getSingleItem(relItem));
            } else {
                throw "Cannot add items with this structure";
            }
        }

        this.apply = function (action, callback) {
            if (action && 'undefined' !== typeof action) this.setAttribute("action", action);
            if (conn && conn.CallAction) {
                conn.CallAction("ApplyItem", this.json, callback);
            } else {
                throw "Invalid connection object.";
            }
        }

        this.forEach = function (callback) {
            var arrayItem = getArrayItem();
            if (arrayItem) {
                for (var i = 0; i < arrayItem.length; i++) {
                    if (callback(new IOM.Item(conn, { "Item": arrayItem[i] })) === false) return;
                }
            } else {
                var singleItem = getSingleItem(self, false);
                if (singleItem) callback(this);
            }
        }

        this.getAttribute = function (attributeName, defaultValue) {
            return this.getProperty("@" + attributeName, defaultValue);
        }

        this.getErrorCode = function () {
            return getErrorProperty("faultcode");
        }

        this.getErrorDetail = function () {
            return getErrorProperty("detail");
        }

        this.getErrorSource = function () {
            return getErrorProperty("faultactor");
        }

        this.getErrorString = function () {
            return getErrorProperty("faultstring");
        }

        this.getID = function () {
            var id = this.getProperty("@id");
            if (!id) id = this.getProperty("id");
            return id;
        }

        this.getItemCount = function () {
            var arrayItem = getArrayItem();

            if (!self.json) {
                return -1;
            } else if (arrayItem) {
                return arrayItem.length;
            } else {
                var errorCode = this.getErrorCode();
                if (errorCode) {
                    if (errorCode === "0") {
                        return 0;
                    } else {
                        return -1;
                    }
                } else {
                    var singleItem = getSingleItem(self, false)
                    if (singleItem) {
                        return 1;
                    } else {
                        return 0;
                    }
                }
            }
        }

        this.getItemByIndex = function (index) {
            var arrayItem = getArrayItem();

            if (arrayItem) {
                return new IOM.Item(conn, { "Item": arrayItem[index] });
            } else if (index === 0) {
                return new IOM.Item(conn, { "Item": getSingleItem() });
            } else {
                return null;
            }
        }

        this.getLockStatus = function () {
            if (this.isNew()) {
                return 0;
            } else {
                switch (this.getProperty("locked_by_id", "none")) {
                    case "none":
                        return 0;
                    case conn.getUserID():
                        return 1;
                    default:
                        return 2;
                }
            }
        }

        this.getNewID = function () {
            return IOM.Framework().getNewID();
        }

        this.getProperty = function (propertyName, defaultValue, lang) {
            var item = getSingleItem();

            if (propertyName && 'undefined' !== typeof propertyName) {
                if (item[propertyName]) {
                    if (item[propertyName]["#text"]) {
                        return item[propertyName]["#text"];
                    } else if (item[propertyName]["Item"]) {
                        if (item[propertyName]["Item"]["@id"]) {
                            return item[propertyName]["Item"]["@id"];
                        } else if (item[propertyName]["Item"]["id"]["#text"]) {
                            return item[propertyName]["Item"]["id"]["#text"];
                        } else {
                            return null;
                        }
                    } else if (item[propertyName]["@is_null"] && item[propertyName]["@is_null"] === "1") {
                        if ('undefined' !== typeof defaultValue) {
                            return defaultValue;
                        } else {
                            return null;
                        }
                    } else {
                        return item[propertyName];
                    }
                } else if ('undefined' !== typeof defaultValue) {
                    return defaultValue;
                } else {
                    return null;
                }
            } else {
                throw "'propertyName' must be specified for Item.getPropery";
            }
        }

        this.getPropertyAttribute = function (propertyName, attributeName, defaultValue, lang) {
            var item = getSingleItem();

            if (propertyName && attributeName && 'undefined' !== typeof propertyName && 'undefined' !== typeof attributeName) {
                if (item[propertyName] && item[propertyName]["@" + attributeName]) {
                    return item[propertyName]["@" + attributeName];
                } else if ('undefined' !== typeof defaultValue) {
                    return defaultValue;
                } else {
                    return null;
                }
            } else {
                throw "'propertyName' and 'attributeName' must be specified for Item.getPropertyAttribute";
            }
        }

        this.getPropertyCondition = function (propertyName, lang) {
            return this.getPropertyAttribute(propertyName, "condition", null, lang);
        }

        this.getPropertyItem = function (propertyName) {
            var item = getSingleItem();

            if (propertyName && 'undefined' !== typeof propertyName) {
                if (propertyName === "id") {
                    return this;
                } else if (item[propertyName]["Item"]) {
                    return new IOM.Item(conn, { "Item": item[propertyName]["Item"] });
                } else if (item[propertyName]["@type"] && item[propertyName]["#text"]) {
                    return new IOM.Item(conn, { "Item": { "@type": item[propertyName]["@type"], "@id": item[propertyName]["#text"], "id": item[propertyName]["#text"]} });
                } else {
                    return null;
                }
            } else {
                throw "'propertyName' must be specified for Item.getPropertyItem";
            }
        }

        this.getRelatedItem = function () {
            return this.getPropertyItem("related_id");
        }

        this.getRelatedItemID = function () {
            return this.getProperty("related_id");
        }

        this.getRelationships = function (itemTypeName) {
            var item = getSingleItem();

            if (itemTypeName && 'undefined' !== typeof itemTypeName) {
                var rel = { "Result": { "Item": []} }
                if (item.Relationships && item.Relationships.Item && Object.prototype.toString.call(item.Relationships.Item) === '[object Array]') {
                    for (var i = 0; i < item.Relationships.Item.length; i++) {
                        if (item.Relationships.Item[i]["@type"] === itemTypeName) {
                            rel.Result.Item.push(item.Relationships.Item[i]);
                        }
                    }
                }
                return new IOM.Item(conn, rel);
            } else {
                return new IOM.Item(conn, { "Result": item.Relationships });
            }
        }

        this.getResult = function () {
            var body = self.json;
            if (self.json["SOAP-ENV:Envelope"] && self.json["SOAP-ENV:Envelope"]["SOAP-ENV:Body"]) {
                body = self.json["SOAP-ENV:Envelope"]["SOAP-ENV:Body"]
            }

            while (body && 'undefined' === typeof body.Result) {
                // Search for a single property which might contain the result.  If there are multiple properties, abort
                var singleProp = null;
                for (var prop in body) {
                    if (body.hasOwnProperty(prop)) {
                        if (singleProp === null) {
                            singleProp = prop;
                        } else {
                            // Multiple properties found
                            return null;
                        }
                    }
                }

                if (singleProp === "Item") {
                    // A result should not be under an Item property
                    return null;
                } else if (singleProp) {
                    body = body[singleProp]
                } else {
                    // No properties found
                    return null;
                }
            }

            if (body && body.Result) {
                return body.Result;
            } else {
                return null;
            }
        }

        this.getType = function () {
            return this.getAttribute("type", "");
        }

        this.isCollection = function () {
            return (getArrayItem() != null);
        }

        this.isEmpty = function () {
            return (this.isError() && this.getErrorCode() === "0");
        }

        this.isError = function () {
            return (getErrorItem() != null);
        }

        this.isNew = function () {
            return (this.getAttribute("isNew", "") === "1");
        }

        this.loadJson = function (json) {
            if (!json || 'undefined' === typeof json) {
                this.json = { "Item": {} };
            } else {
                this.json = json;
            }
        }

        this.setAttribute = function (attributeName, attributeValue) {
            var item = getSingleItem();

            if (attributeName) {
                if (attributeValue && 'undefined' !== typeof attributeValue) {
                    item["@" + attributeName] = attributeValue;
                } else {
                    delete item["@" + attributeName];
                }
            } else {
                throw "'attributeName' must be specified for Item.setProperty";
            }
        }

        this.setID = function (id) {
            this.setAttribute("id", id);
        }

        this.setNewID = function () {
            return this.setID(IOM.Framework().getNewID());
        }

        this.setProperty = function (propertyName, propertyValue, lang) {
            var item = getSingleItem();

            if (propertyName && 'undefined' !== typeof propertyName) {
                if (item[propertyName]) {
                    if (propertyValue && 'undefined' !== typeof propertyValue) {
                        if (item[propertyName]["@is_null"]) delete item[propertyName]["@is_null"];
                        if (item[propertyName]["#text"]) {
                            item[propertyName]["#text"] = propertyValue;
                        } else {
                            item[propertyName] = propertyValue;
                        }
                    } else {
                        if (item[propertyName]["#text"]) {
                            item[propertyName]["#text"] = null;
                            item[propertyName]["@is_null"] = "1";
                        } else {
                            item[propertyName] = { "@is_null": "1", "#text": null };
                        }
                    }
                } else {
                    if (propertyValue && 'undefined' !== typeof propertyValue) {
                        item[propertyName] = propertyValue;
                    } else {
                        item[propertyName] = { "@is_null": "1", "#text": null };
                    }
                }
            } else {
                throw "'propertyName' must be specified for Item.setProperty";
            }
        }

        this.setPropertyAttribute = function (propertyName, attributeName, attributeValue, lang) {
            var item = getSingleItem();

            if (propertyName && attributeName && 'undefined' !== typeof propertyName && 'undefined' !== typeof attributeName) {
                attributeName = "@" + attributeName;
                if (item[propertyName]) {
                    // Test if the property is a simple string
                    if (item[propertyName].substring) {
                        if (attributeValue && 'undefined' !== typeof attributeValue) {
                            var text = item[propertyName]
                            item[propertyName] = new Object();
                            item[propertyName][attributeName] = attributeValue;
                            item[propertyName]["#text"] = text;
                        }
                    } else {
                        if (attributeValue && 'undefined' !== typeof attributeValue) {
                            item[propertyName][attributeName] = attributeValue;
                        } else {
                            delete item[propertyName][attributeName];
                        }
                    }
                } else {
                    if (attributeValue && 'undefined' !== typeof attributeValue) {
                        item[propertyName] = new Object();
                        item[propertyName][attributeName] = attributeValue;
                    }
                }
            } else {
                throw "'propertyName' and 'attributeName' must be specified for Item.setPropertyAttribute";
            }
        }

        this.setPropertyCondition = function (propertyName, condition, lang) {
            this.setPropertyAttribute(propertyName, "condition", condition, lang);
        }

        this.setPropertyItem = function (propertyName, itemData) {
            var newItem = getSingleItem(itemData, true);
            var item = getSingleItem();

            if (propertyName && 'undefined' !== typeof propertyName) {
                if (item[propertyName]) {
                    if (newItem && 'undefined' !== typeof newItem) {
                        if (item[propertyName]["@is_null"]) delete item[propertyName]["@is_null"];
                        if (item[propertyName]["#text"]) delete item[propertyName]["#text"];
                        item[propertyName] = { "Item": newItem };
                    } else {
                        if (item[propertyName]["#text"]) {
                            item[propertyName]["#text"] = null;
                            item[propertyName]["@is_null"] = "1";
                        } else {
                            item[propertyName] = { "@is_null": "1", "#text": null };
                        }
                    }
                } else {
                    if (newItem && 'undefined' !== typeof newItem) {
                        item[propertyName] = { "Item": newItem };
                    } else {
                        item[propertyName] = { "@is_null": "1", "#text": null };
                    }
                }
            } else {
                throw "'propertyName' must be specified for Item.setPropertyItem";
            }
        }

        this.setType = function (itemTypeName) {
            this.setAttribute("type", itemTypeName);
        }
    },
    ItemHelper: {
        apply: function (item, action, callback) {
            if (item) {
                if (item.dom) {
                    callback(item.apply(action));
                } else {
                    item.apply(action, callback);
                }
            }
        },
        forEach: function (item, callback) {
            if (item) {
                if (item.forEach) {
                    item.forEach(callback);
                } else {
                    for (var i = 0; i < item.getItemCount(); i++) {
                        if (callback(item.getItemByIndex(i)) === false) return;
                    }
                }
            }
        }
    },
    Framework: function () {
        var _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

        function _utf8_decode(utftext) {
            var string = "";
            var i = 0;
            var c = c1 = c2 = 0;

            while (i < utftext.length) {

                c = utftext.charCodeAt(i);

                if (c < 128) {
                    string += String.fromCharCode(c);
                    i++;
                }
                else if ((c > 191) && (c < 224)) {
                    c2 = utftext.charCodeAt(i + 1);
                    string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                    i += 2;
                }
                else {
                    c2 = utftext.charCodeAt(i + 1);
                    c3 = utftext.charCodeAt(i + 2);
                    string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                    i += 3;
                }

            }
            return string;
        }
        function _utf8_encode(string) {
            string = string.replace(/\r\n/g, "\n");
            var utftext = "";

            for (var n = 0; n < string.length; n++) {

                var c = string.charCodeAt(n);

                if (c < 128) {
                    utftext += String.fromCharCode(c);
                }
                else if ((c > 127) && (c < 2048)) {
                    utftext += String.fromCharCode((c >> 6) | 192);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
                else {
                    utftext += String.fromCharCode((c >> 12) | 224);
                    utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                    utftext += String.fromCharCode((c & 63) | 128);
                }

            }

            return utftext;
        }

        return {
            toBase64String: function (input) {
                var output = "";
                var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
                var i = 0;

                input = _utf8_encode(input);

                while (i < input.length) {

                    chr1 = input.charCodeAt(i++);
                    chr2 = input.charCodeAt(i++);
                    chr3 = input.charCodeAt(i++);

                    enc1 = chr1 >> 2;
                    enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
                    enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
                    enc4 = chr3 & 63;

                    if (isNaN(chr2)) {
                        enc3 = enc4 = 64;
                    } else if (isNaN(chr3)) {
                        enc4 = 64;
                    }

                    output = output +
          _keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
          _keyStr.charAt(enc3) + _keyStr.charAt(enc4);

                }

                return output;
            },
            fromBase64String: function (input) {
                var output = "";
                var chr1, chr2, chr3;
                var enc1, enc2, enc3, enc4;
                var i = 0;

                input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

                while (i < input.length) {

                    enc1 = _keyStr.indexOf(input.charAt(i++));
                    enc2 = _keyStr.indexOf(input.charAt(i++));
                    enc3 = _keyStr.indexOf(input.charAt(i++));
                    enc4 = _keyStr.indexOf(input.charAt(i++));

                    chr1 = (enc1 << 2) | (enc2 >> 4);
                    chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                    chr3 = ((enc3 & 3) << 6) | enc4;

                    output = output + String.fromCharCode(chr1);

                    if (enc3 != 64) {
                        output = output + String.fromCharCode(chr2);
                    }
                    if (enc4 != 64) {
                        output = output + String.fromCharCode(chr3);
                    }

                }

                output = _utf8_decode(output);

                return output;

            },
            encodePassword: function (value) {
                value = "<pw>" + value + "</pw>";
                var key = value.length;
                var builder = "";

                for (var i = 0; i < value.length; i++) {
                    builder += String.fromCharCode(value.charCodeAt(i) ^ key);
                }

                return IOM.Framework().toBase64String(builder);
            },
            getNewID: function () {
                // From http://baagoe.com/en/RandomMusings/javascript/
                // Johannes Baage <baagoe@baagoe.com>, 2010
                function Mash() {
                    var n = 0xefc8249d;

                    var mash = function (data) {
                        data = data.toString();
                        for (var i = 0; i < data.length; i++) {
                            n += data.charCodeAt(i);
                            var h = 0.02519603282416938 * n;
                            n = h >>> 0;
                            h -= n;
                            h *= n;
                            n = h >>> 0;
                            h -= n;
                            n += h * 0x100000000; // 2^32
                        }
                        return (n >>> 0) * 2.3283064365386963e-10; // 2^-32
                    };

                    mash.version = 'Mash 0.9';
                    return mash;
                }

                // Random Number Generator From http://baagoe.com/en/RandomMusings/javascript/
                function Alea() {
                    return (function (args) {
                        // Johannes Baage <baagoe@baagoe.com>, 2010
                        var s0 = 0;
                        var s1 = 0;
                        var s2 = 0;
                        var c = 1;

                        if (args.length == 0) {
                            args = [+new Date];
                        }
                        var mash = Mash();
                        s0 = mash(' ');
                        s1 = mash(' ');
                        s2 = mash(' ');

                        for (var i = 0; i < args.length; i++) {
                            s0 -= mash(args[i]);
                            if (s0 < 0) {
                                s0 += 1;
                            }
                            s1 -= mash(args[i]);
                            if (s1 < 0) {
                                s1 += 1;
                            }
                            s2 -= mash(args[i]);
                            if (s2 < 0) {
                                s2 += 1;
                            }
                        }
                        mash = null;

                        var random = function () {
                            var t = 2091639 * s0 + c * 2.3283064365386963e-10; // 2^-32
                            s0 = s1;
                            s1 = s2;
                            return s2 = t - (c = t | 0);
                        };
                        random.uint32 = function () {
                            return random() * 0x100000000; // 2^32
                        };
                        random.fract53 = function () {
                            return random() +
            (random() * 0x200000 | 0) * 1.1102230246251565e-16; // 2^-53
                        };
                        random.version = 'Alea 0.9';
                        random.args = args;
                        return random;

                    } (Array.prototype.slice.call(arguments)));
                };

                var rnd = Alea(navigator.userAgent, +new Date);

                //'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'
                return 'xxxxxxxxxxxx4xxxyxxxxxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                    var r = rnd() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
                    return v.toString(16);
                }).toUpperCase();
            },
            calcMD5: function (str) {
                if (!str) return '';

                /*
                * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
                * Digest Algorithm, as defined in RFC 1321.
                * Version 2.1 Copyright (C) Paul Johnston 1999 - 2002.
                * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
                * Distributed under the BSD License
                * See http://pajhome.org.uk/crypt/md5 for more info.
                */

                /*
                * Configurable variables. You may need to tweak these to be compatible with
                * the server-side, but the defaults work in most cases.
                */
                var hexcase = 0;  /* hex output format. 0 - lowercase; 1 - uppercase        */
                var b64pad = ""; /* base-64 pad character. "=" for strict RFC compliance   */
                var chrsz = 8;  /* bits per input character. 8 - ASCII; 16 - Unicode      */

                /*
                * These are the functions you'll usually want to call
                * They take string arguments and return either hex or base-64 encoded strings
                */
                function hex_md5(s) { return binl2hex(core_md5(str2binl(s), s.length * chrsz)); }
                function b64_md5(s) { return binl2b64(core_md5(str2binl(s), s.length * chrsz)); }
                function str_md5(s) { return binl2str(core_md5(str2binl(s), s.length * chrsz)); }
                function hex_hmac_md5(key, data) { return binl2hex(core_hmac_md5(key, data)); }
                function b64_hmac_md5(key, data) { return binl2b64(core_hmac_md5(key, data)); }
                function str_hmac_md5(key, data) { return binl2str(core_hmac_md5(key, data)); }

                /*
                * Calculate the MD5 of an array of little-endian words, and a bit length
                */
                function core_md5(x, len) {
                    /* append padding */
                    x[len >> 5] |= 0x80 << ((len) % 32);
                    x[(((len + 64) >>> 9) << 4) + 14] = len;

                    var a = 1732584193;
                    var b = -271733879;
                    var c = -1732584194;
                    var d = 271733878;

                    for (var i = 0; i < x.length; i += 16) {
                        var olda = a;
                        var oldb = b;
                        var oldc = c;
                        var oldd = d;

                        a = md5_ff(a, b, c, d, x[i + 0], 7, -680876936);
                        d = md5_ff(d, a, b, c, x[i + 1], 12, -389564586);
                        c = md5_ff(c, d, a, b, x[i + 2], 17, 606105819);
                        b = md5_ff(b, c, d, a, x[i + 3], 22, -1044525330);
                        a = md5_ff(a, b, c, d, x[i + 4], 7, -176418897);
                        d = md5_ff(d, a, b, c, x[i + 5], 12, 1200080426);
                        c = md5_ff(c, d, a, b, x[i + 6], 17, -1473231341);
                        b = md5_ff(b, c, d, a, x[i + 7], 22, -45705983);
                        a = md5_ff(a, b, c, d, x[i + 8], 7, 1770035416);
                        d = md5_ff(d, a, b, c, x[i + 9], 12, -1958414417);
                        c = md5_ff(c, d, a, b, x[i + 10], 17, -42063);
                        b = md5_ff(b, c, d, a, x[i + 11], 22, -1990404162);
                        a = md5_ff(a, b, c, d, x[i + 12], 7, 1804603682);
                        d = md5_ff(d, a, b, c, x[i + 13], 12, -40341101);
                        c = md5_ff(c, d, a, b, x[i + 14], 17, -1502002290);
                        b = md5_ff(b, c, d, a, x[i + 15], 22, 1236535329);

                        a = md5_gg(a, b, c, d, x[i + 1], 5, -165796510);
                        d = md5_gg(d, a, b, c, x[i + 6], 9, -1069501632);
                        c = md5_gg(c, d, a, b, x[i + 11], 14, 643717713);
                        b = md5_gg(b, c, d, a, x[i + 0], 20, -373897302);
                        a = md5_gg(a, b, c, d, x[i + 5], 5, -701558691);
                        d = md5_gg(d, a, b, c, x[i + 10], 9, 38016083);
                        c = md5_gg(c, d, a, b, x[i + 15], 14, -660478335);
                        b = md5_gg(b, c, d, a, x[i + 4], 20, -405537848);
                        a = md5_gg(a, b, c, d, x[i + 9], 5, 568446438);
                        d = md5_gg(d, a, b, c, x[i + 14], 9, -1019803690);
                        c = md5_gg(c, d, a, b, x[i + 3], 14, -187363961);
                        b = md5_gg(b, c, d, a, x[i + 8], 20, 1163531501);
                        a = md5_gg(a, b, c, d, x[i + 13], 5, -1444681467);
                        d = md5_gg(d, a, b, c, x[i + 2], 9, -51403784);
                        c = md5_gg(c, d, a, b, x[i + 7], 14, 1735328473);
                        b = md5_gg(b, c, d, a, x[i + 12], 20, -1926607734);

                        a = md5_hh(a, b, c, d, x[i + 5], 4, -378558);
                        d = md5_hh(d, a, b, c, x[i + 8], 11, -2022574463);
                        c = md5_hh(c, d, a, b, x[i + 11], 16, 1839030562);
                        b = md5_hh(b, c, d, a, x[i + 14], 23, -35309556);
                        a = md5_hh(a, b, c, d, x[i + 1], 4, -1530992060);
                        d = md5_hh(d, a, b, c, x[i + 4], 11, 1272893353);
                        c = md5_hh(c, d, a, b, x[i + 7], 16, -155497632);
                        b = md5_hh(b, c, d, a, x[i + 10], 23, -1094730640);
                        a = md5_hh(a, b, c, d, x[i + 13], 4, 681279174);
                        d = md5_hh(d, a, b, c, x[i + 0], 11, -358537222);
                        c = md5_hh(c, d, a, b, x[i + 3], 16, -722521979);
                        b = md5_hh(b, c, d, a, x[i + 6], 23, 76029189);
                        a = md5_hh(a, b, c, d, x[i + 9], 4, -640364487);
                        d = md5_hh(d, a, b, c, x[i + 12], 11, -421815835);
                        c = md5_hh(c, d, a, b, x[i + 15], 16, 530742520);
                        b = md5_hh(b, c, d, a, x[i + 2], 23, -995338651);

                        a = md5_ii(a, b, c, d, x[i + 0], 6, -198630844);
                        d = md5_ii(d, a, b, c, x[i + 7], 10, 1126891415);
                        c = md5_ii(c, d, a, b, x[i + 14], 15, -1416354905);
                        b = md5_ii(b, c, d, a, x[i + 5], 21, -57434055);
                        a = md5_ii(a, b, c, d, x[i + 12], 6, 1700485571);
                        d = md5_ii(d, a, b, c, x[i + 3], 10, -1894986606);
                        c = md5_ii(c, d, a, b, x[i + 10], 15, -1051523);
                        b = md5_ii(b, c, d, a, x[i + 1], 21, -2054922799);
                        a = md5_ii(a, b, c, d, x[i + 8], 6, 1873313359);
                        d = md5_ii(d, a, b, c, x[i + 15], 10, -30611744);
                        c = md5_ii(c, d, a, b, x[i + 6], 15, -1560198380);
                        b = md5_ii(b, c, d, a, x[i + 13], 21, 1309151649);
                        a = md5_ii(a, b, c, d, x[i + 4], 6, -145523070);
                        d = md5_ii(d, a, b, c, x[i + 11], 10, -1120210379);
                        c = md5_ii(c, d, a, b, x[i + 2], 15, 718787259);
                        b = md5_ii(b, c, d, a, x[i + 9], 21, -343485551);

                        a = safe_add(a, olda);
                        b = safe_add(b, oldb);
                        c = safe_add(c, oldc);
                        d = safe_add(d, oldd);
                    }
                    return Array(a, b, c, d);

                }

                /*
                * These functions implement the four basic operations the algorithm uses.
                */
                function md5_cmn(q, a, b, x, s, t) {
                    return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s), b);
                }
                function md5_ff(a, b, c, d, x, s, t) {
                    return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
                }
                function md5_gg(a, b, c, d, x, s, t) {
                    return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
                }
                function md5_hh(a, b, c, d, x, s, t) {
                    return md5_cmn(b ^ c ^ d, a, b, x, s, t);
                }
                function md5_ii(a, b, c, d, x, s, t) {
                    return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
                }

                /*
                * Calculate the HMAC-MD5, of a key and some data
                */
                function core_hmac_md5(key, data) {
                    var bkey = str2binl(key);
                    if (bkey.length > 16) bkey = core_md5(bkey, key.length * chrsz);

                    var ipad = Array(16), opad = Array(16);
                    for (var i = 0; i < 16; i++) {
                        ipad[i] = bkey[i] ^ 0x36363636;
                        opad[i] = bkey[i] ^ 0x5C5C5C5C;
                    }

                    var hash = core_md5(ipad.concat(str2binl(data)), 512 + data.length * chrsz);
                    return core_md5(opad.concat(hash), 512 + 128);
                }

                /*
                * Add integers, wrapping at 2^32. This uses 16-bit operations internally
                * to work around bugs in some JS interpreters.
                */
                function safe_add(x, y) {
                    var lsw = (x & 0xFFFF) + (y & 0xFFFF);
                    var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
                    return (msw << 16) | (lsw & 0xFFFF);
                }

                /*
                * Bitwise rotate a 32-bit number to the left.
                */
                function bit_rol(num, cnt) {
                    return (num << cnt) | (num >>> (32 - cnt));
                }

                /*
                * Convert a string to an array of little-endian words
                * If chrsz is ASCII, characters >255 have their hi-byte silently ignored.
                */
                function str2binl(str) {
                    var bin = Array();
                    var mask = (1 << chrsz) - 1;
                    for (var i = 0; i < str.length * chrsz; i += chrsz)
                        bin[i >> 5] |= (str.charCodeAt(i / chrsz) & mask) << (i % 32);
                    return bin;
                }

                /*
                * Convert an array of little-endian words to a string
                */
                function binl2str(bin) {
                    var str = "";
                    var mask = (1 << chrsz) - 1;
                    for (var i = 0; i < bin.length * 32; i += chrsz)
                        str += String.fromCharCode((bin[i >> 5] >>> (i % 32)) & mask);
                    return str;
                }

                /*
                * Convert an array of little-endian words to a hex string.
                */
                function binl2hex(binarray) {
                    var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
                    var str = "";
                    for (var i = 0; i < binarray.length * 4; i++) {
                        str += hex_tab.charAt((binarray[i >> 2] >> ((i % 4) * 8 + 4)) & 0xF) +
               hex_tab.charAt((binarray[i >> 2] >> ((i % 4) * 8)) & 0xF);
                    }
                    return str;
                }

                /*
                * Convert an array of little-endian words to a base-64 string
                */
                function binl2b64(binarray) {
                    var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
                    var str = "";
                    for (var i = 0; i < binarray.length * 4; i += 3) {
                        var triplet = (((binarray[i >> 2] >> 8 * (i % 4)) & 0xFF) << 16)
                | (((binarray[i + 1 >> 2] >> 8 * ((i + 1) % 4)) & 0xFF) << 8)
                | ((binarray[i + 2 >> 2] >> 8 * ((i + 2) % 4)) & 0xFF);
                        for (var j = 0; j < 4; j++) {
                            if (i * 8 + j * 6 > binarray.length * 32) str += b64pad;
                            else str += tab.charAt((triplet >> 6 * (3 - j)) & 0x3F);
                        }
                    }
                    return str;
                }

                return hex_md5(str);
            }
        };
    }
}

IOM.Item.prototype.toString = function() {
  return JSON.stringify(this.json);
}